@ECHO off

SETLOCAL

ECHO.
ECHO IBM Business Process Manager 8.5.0 Migration
ECHO.

SET SCRIPT_DIR=%~dp0
PUSHD %SCRIPT_DIR%..\..\..\..\..\bin
CALL "setupCmdLine.bat" %*
POPD

cd /d "%SCRIPT_DIR%"

IF NOT "%USER_INSTALL_ROOT%"=="" GOTO setupArguments
ECHO .
ECHO Profile does not exist.
ECHO.
SET RC=1
GOTO help

:setupArguments
SET RC=0
SET TARGET=upgrade
SET WAS_HOME_PROP=-Dwas.install.root="%WAS_HOME%"
SET NODE_NAME_PROP=
SET SERVER_NAME_PROP=
SET PROC_SERVER_PROFILE_PROP=
SET DE_CONFIG_FILE_PROP=
SET CONFIG_PROP=-Dteamworks.upgrade.settingsFile=upgrade.properties
SET MAPPING_PROP=-Dteamworks.upgrade.configFile=config.xml
SET LOGGING_PROP=-Dcom.lombardisoftware.ant.JULDefaultLogger.level=DEBUG -Djava.util.logging.config.file="%SCRIPT_DIR%logging.properties" -Dtw.log4j.init=false
SET LOGGING_FILTER_PROP=-Dcom.lombardi.logging.StringFilter.excludes=equals(WSVR0072W);equals(WSVR0801I);equals(WKSP0500);startsWith(ssl.);startsWith(security.);startsWith(FFDC1003I);equals(WSVR0801I);equals(WKSP0500);regexp(^Class.+loaded.from.ant.loader..parentFirst.);regexp(^Class.+loaded.from.parent.loader..parentFirst.);regexp(^Finding.class.+\..+\..+);regexp(^Loaded.from.+\.jar..+\.class$)
SET LOGGING_PROP=%LOGGING_PROP% %LOGGING_FILTER_PROP%
SET ANT_PROPS=-q -e -logger com.lombardisoftware.ant.JULDefaultLogger
SET CONDITION_OR=false

:processArguments
IF "%1" == "-?" GOTO help
IF "%1" == "-help" GOTO help

SET CONDITION_OR=false
IF "%1" == "-c" SET CONDITION_OR=true
IF "%1" == "-config" SET CONDITION_OR=true
IF "%CONDITION_OR%" == "true" (
	IF "%2"=="" (
		GOTO NoValueSpecified
	) ELSE (
		SET CONFIG_PROP="-Dteamworks.upgrade.settingsFile=%2%"&SHIFT&SHIFT&GOTO processArguments
	)
)

IF "%1" == "-cleanAndRestart" SET TARGET="upgrade-restart"&SHIFT&GOTO processArguments

IF "%1" == "-s" SET TARGET="upgrade-status"&SHIFT&GOTO processArguments
IF "%1" == "-status" SET TARGET="upgrade-status"&SHIFT&GOTO processArguments

SET CONDITION_OR=false
IF "%1" == "-b" SET CONDITION_OR=true
IF "%1" == "-buildSettingsFile" SET CONDITION_OR=true
IF "%CONDITION_OR%" == "true" (
	IF "%2"=="" (
		GOTO NoValueSpecified
	) ELSE (
		SET TARGET="create-upgrade-mapping-file"&SET MAPPING_PROP="-Dteamworks.upgrade.configFile=%2"&SHIFT&SHIFT&GOTO processArguments
	)
)

SET CONDITION_OR=false
IF "%1" == "-g" SET CONDITION_OR=true
IF "%1" == "-generateAdhocReport" SET CONDITION_OR=true
IF "%CONDITION_OR%" == "true" (
	IF "%2"=="" (
		GOTO NoValueSpecified
	) ELSE (
		SET TARGET="generate-adhoc-reports-package"&SET ADHOC_PACKAGE_PATH="-DadhocPackagePath=%2%"&SHIFT&SHIFT&GOTO processArguments
	)
)

IF "%1"=="-profileName" (
	IF "%2"=="" (
		GOTO NoValueSpecified
	) ELSE (
		SET PROC_SERVER_PROFILE_PROP=-DprocsrvProfileName=%2%&SHIFT&SHIFT&GOTO processArguments
	)
)

IF "%1"=="-serverName" (
	IF "%2"=="" (
		GOTO NoValueSpecified
	) ELSE (
		SET SERVER_NAME_PROP=-DserverName=%2%&SHIFT&SHIFT&GOTO processArguments
	)
)

IF "%1"=="-nodeName" (
	IF "%2"=="" (
		GOTO NoValueSpecified
	) ELSE (
		SET NODE_NAME_PROP=-DnodeName=%2%&SHIFT&SHIFT&GOTO processArguments
	)
)

IF "%1"=="-perfServerName" (
	IF "%2"== "" (
		GOTO NoValueSpecified
	) ELSE (
		SET PERF_SERVER_NAME_PROP=-DperfServerName=%2%&SHIFT&SHIFT&GOTO processArguments
	)
)

IF "%1"=="-perfNodeName" (
	IF "%2"== "" (
		GOTO NoValueSpecified
	) ELSE (
		SET PERF_NODE_NAME_PROP=-DperfNodeName=%2%&SHIFT&SHIFT&GOTO processArguments
	)
)

IF "%1"=="-deConfigFile" (
	IF "%2"== "" (
		GOTO NoValueSpecified
	) ELSE (
		SET DE_CONFIG_FILE_PROP=-DdeConfigFile=%2%&SHIFT&SHIFT&GOTO processArguments
	)
)

IF NOT "%1"=="" (
	SET INVALID_PARAM=%1%
	SET MAPPING_PROP="-Dteamworks.upgrade.configFile=%~f1"
	SHIFT
)
IF NOT "%1" == "" (
	ECHO Invalid parameter: %INVALID_PARAM%, please correct it and try again.
	GOTO help
)

SET CLASSPATH=%SCRIPT_DIR%
SET CLASSPATH=%CLASSPATH%;%SCRIPT_DIR%resources
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%\BPM\Lombardi\lib\twant.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%\BPM\Lombardi\lib\langutil.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%\BPM\Lombardi\lib\ant-contrib.jar
SET CLASSPATH=%CLASSPATH%;%WAS_HOME%\BPM\Lombardi\lib\commons-logging.jar
SET CLASSPATH=%CLASSPATH%;%SCRIPT_DIR%lib\ant.jar
SET CLASSPATH=%CLASSPATH%;%SCRIPT_DIR%lib\ant-launcher.jar
SET CLASSPATH=%CLASSPATH%;%SCRIPT_DIR%lib\ant-nodeps.jar

SET UPGRADE_RESOURCE_DIR=%WAS_HOME%\BPM\Lombardi\tools\upgrade\upgrade_6x\resources\
SET APP_JAVA_POLICY=-Djava.security.policy="file:%UPGRADE_RESOURCE_DIR%java.policy"

SET ENABLE_DEBUG=false
IF %ENABLE_DEBUG%==true (
   SET DEBUG_PROP=-Xdebug -Xrunjdwp:transport=dt_socket,address=7780,server=y,suspend=y   
) ELSE (
   SET DEBUG_PROP=
)

"%JAVA_HOME%/bin/java" -cp "%CLASSPATH%" %WAS_HOME_PROP% %USER_INSTALL_PROP% %APP_JAVA_POLICY% %NODE_NAME_PROP% %DE_CONFIG_FILE_PROP% %SERVER_NAME_PROP% %PERF_NODE_NAME_PROP% %PROC_SERVER_PROFILE_PROP% %PERF_SERVER_NAME_PROP% %ADHOC_PACKAGE_PATH% %CONFIG_PROP% %MAPPING_PROP% %LOGGING_PROP% %DEBUG_PROP% -Xms1024m -Xmx2048m org.apache.tools.ant.Main -buildfile "%SCRIPT_DIR%upgrade.xml" %ANT_PROPS% %TARGET%
SET RC=%ERRORLEVEL%
GOTO END

:help
ECHO.
ECHO Starts or continues the upgrade.
ECHO.
ECHO Usage:
ECHO.
ECHO    upgrade_6x.bat [options...]
ECHO.
ECHO Example:
ECHO    Build the mapping file:
ECHO       upgrade_6x.bat -c upgrade.properties -b map.xml -profileName DmgrProfileName -deConfigFile c:/deconfig.xml
ECHO    Upgrade the runtime environment:
ECHO       upgrade_6x.bat -c upgrade.properties -profileName DmgrProfileName -deConfigFile c:/deconfig.xml map.xml
ECHO.
ECHO Options:
ECHO    -?, -help                             This help message
ECHO    -c, -config ^<file^>                  Upgrade config properties file, defaults to upgrade.properties
ECHO    -s, -status                           Shows the currently executing phase along with any additional information (does not continue upgrade)
ECHO    -b, -buildSettingsFile ^<file^>       Creates a base upgrade settings file that includes base process instance map to be filled in
ECHO    -cleanAndRestart                      Restart the upgrade (cleans the DBs and starts the copy of data again)
ECHO    -profileName ^<name^>                 Profile name
ECHO    -nodeName ^<name^>                    Node name in ND environment (optional)
ECHO    -serverName ^<name^>                  Server name in ND environment (optional)
ECHO    -perfNodeName ^<name^>                Node name of Performance Data Warehouse in ND environment (optional)
ECHO    -perfServerName ^<name^>              Server name of Performance Data Warehouse in ND environment (optional)
ECHO    -g, -generateAdhocReport ^<path^>     Create the installation package for Ad-Hoc Reports on target process-center (in process-center off-line mode, and want to migrate Ad-Hoc reports, you need to generate this package first and place it into install-app folder before migration.)
ECHO    -deConfigFile  ^<full path^>          Full path of DE config file
ECHO.
GOTO end

:NoValueSpecified
ECHO No value specified for parameter %1
GOTO help

:end
ECHO.
EXIT /B %RC%
ENDLOCAL
